# PostRating


#### 项目介绍
Typecho文章评分插件——PostRating优化修复版


#### 优化说明
这个插件由 Willin Kan 大神很早前做的，我后来有这个需求找到结果用不了，所以自己修复并优化后发上来。

- 修复前端无法评分
- 修复插件后台无法删除评分
- 修复插件后台文章评分勾选删除功能
- 优化插件设置页面，替换 Google JQ 为 Bootcss JQ
- 优化后台评分页面样式
- 取消后台评分文章新窗口打开
- 优化前端评分显示样式


#### 安装教程

上传插件到服务器，改名称为`PostRating`，博客后台启用插件，并设置显示样式等。

在主题的文章页面post.php，需要显示的地方调用以下代码：

`<?php PostRating_Plugin::output(); ?> `

#### 前端示例图
![未评分](https://images.gitee.com/uploads/images/2019/0111/112702_a3e1b2f6_424874.png "未评分")
![评分](https://images.gitee.com/uploads/images/2019/0111/112814_a2596f94_424874.png "评分")
![已评分](https://images.gitee.com/uploads/images/2019/0111/112904_51a871c2_424874.png "已评分")

#### 后台示例图
![总文章评分管理](https://images.gitee.com/uploads/images/2019/0111/113154_2ecb539a_424874.png "总文章评分管理")
![单文章评分管理](https://images.gitee.com/uploads/images/2019/0111/113247_dc84c812_424874.png "单文章评分管理")
![插件设置](https://images.gitee.com/uploads/images/2019/0111/115343_a212484e_424874.jpeg "插件设置")