<?php
/**
 * 文章评分管理
 */
class_exists('Typecho_Widget') or die('This file can not be loaded directly.');
include 'header.php';
include 'menu.php';

$db = Typecho_Db::get();
$postrating = $db->getPrefix() . 'postrating';
$options = Typecho_Widget::widget('Widget_Options');
$contents = Typecho_Widget::widget('Widget_Abstract_Contents');
$hash = substr(md5(Typecho_Widget::widget('Widget_User')->login), -10); // 安全密鑰, 別人無法得知此數值



if (isset($_GET['cid'])) {

    // 取得單篇文章
    $result = $contents->push($db->fetchRow($contents->select()->where('table.contents.cid = ?', $_GET['cid'])));

    // 取得單篇文章的評分
    $query = $db->fetchAll($db->select()->from('table.postrating')->where('cid = ?', $_GET['cid'])->order('created', Typecho_Db::SORT_DESC));
}

?>
<div class="main">
    <div class="body container">
        <?php include 'page-title.php'; ?><?php if (isset($query)) echo '<label class="typecho-label">文章: 《<a href="', $result['permalink'], '">', $result['title'], '</a>》下的评分</label>'; ?>
        <div class="row typecho-page-main" role="main">
            <div class="col-mb-12 typecho-list">

                <div class="typecho-list-operate clearfix">
                    <form method="get">
                        <div class="operate">
                    <?php if (isset($query)) { ?>
                    <a href="<?php $url = explode('&cid=', $_SERVER['REQUEST_URI']); echo htmlspecialchars($url[0]); ?>" class="button">&#9650; 返回上层</a>
                    <?php } ?>
                        <label class="operate-button"><input type="checkbox" class="typecho-table-select-all" style="width: 16px; height: 16px;" />全选</label> / 
                        <span class="operate-button operate-delete typecho-table" style="cursor: pointer;" onclick="req_dou(<?php if (isset($query)) { ?>'created'<?php }else{ ?>'cid'<?php } ?>)">删除评分</span>
                        </div>
                    </form>
                </div>

<style>
    th.center,td.center{
        text-align: center;
    }
</style>

<?php
if (isset($query)) {

/* 單篇文章 */
?>
                 <form method="post" name="manage_posts" class="operate-form">
                     <div class="typecho-table-wrap">
                    <table class="typecho-list-table">
                    <colgroup>
                        <col width="30"/>
                        <col width="80"/>
                        <col width="160"/>
                        <col width="200"/>
                        <col width="200"/>
                        <col width="100"/>
                    </colgroup>
                    <thead>
                        <tr>
                            <th class="typecho-radius-topleft"> </th>
                            <th> </th>
                            <th class="center">日期</th>
                            <th class="center">评分</th>
                            <th class="center">IP</th>
                            <th class="center typecho-radius-topright">评分者</th>
                        </tr>
                    </thead>
                    <tbody>
                      <?php if(!empty($query)): ?>
                        <?php foreach ($query as $row) { ?>
                        <tr id="created-<?php echo $row['created']; ?>">

                            <td><input type="checkbox" value="<?php echo $row['created']; ?>" name="created" onclick="checkeds(this)"/></td>

                            <td class="center"><a style="cursor:pointer" onclick="req(this);">删除</a></td>

                            <td class="center"><?php echo gmdate('Y-m-d H:i', $row['created']); ?></td>

                            <td style="padding-left:90px;color:#E47E00"><?php $rating = $row['rating']; $color = $rating == 5 ? 'f44' : ($rating == 4 ? 'f80' : ($rating == 3 ? 'bb0': ($rating == 2 ? '0a0' : '555')));for($i = 0; $i < $row['rating']; $i++) { echo "<span style='color:#$color'>★</span>"; } ?></td>

                            <td class="center"><?php echo $row['ip']; ?></td>

                            <td class="center"><?php echo $row['name']; ?></td>

                        </tr>
                        <?php } ?>

                        <?php else: ?>
                        <tr>
                          <td colspan="6"><h6 class="typecho-list-table-title">没有任何評分</h6></td>
                        </tr>
                        <?php endif; ?>

                    </tbody>
                </table>

                <input type="hidden" name="hash" value="<?php echo $hash; ?>" />
                <input type="hidden" name="do" value="" />
                </div>
                </form>

<?php

} else { 

/* 文章總覽 */

    // 取得有評分的 cid 及 rating
    $query = $db->fetchAll($db->select('cid', 'rating')->from('table.postrating'));
    foreach ($query as $row) {
        $rating_cid[] = $row['cid'];
        $rating[$row['cid']][] = $row['rating'];
    }

    // 取得所有 cid
    $post_cid = Typecho_Common::arrayFlatten($db->fetchAll($db->select('cid')->from('table.contents')), 'cid');

    // 刪除不存在 cid 的評分 (若文章已刪除, 就要刪除此 cid 評分)
    $query = isset($rating_cid) ? array_diff(array_unique($rating_cid), $post_cid) : '';
    if ($query) {
        $select = $db->delete('table.postrating');
        foreach ($query as $row) {
            $select->orWhere('cid = ?', $row);
        }
        $db->query($select);
    }
?>
                 <form method="post" name="manage_posts" class="operate-form">
                  <div class="typecho-table-wrap">
                   <table class="typecho-list-table">
                    <colgroup>
                        <col width="25"/>
                        <col width="50"/>
                        <col width="20"/>
                        <col width="220"/>
                        <col width="40"/>
                        <col width="70"/>
                        <col width="90"/>
                        <col width="90"/>
                        <col width="90"/>
                        <col width="90"/>
                    </colgroup>
                    <thead>
                        <tr>
                            <th class="typecho-radius-topleft"> </th>
                            <th class="center">cid</th>
                            <th> </th>
                            <th class="center">标题</th>
                            <th> </th>
                            <th class="center">评分人数</th>
                            <th class="center">累计分数</th>
                            <th class="center">平均得分</th>
                            <th class="center">作者</th>
                            <th class="center typecho-radius-topright">分类</th>
                        </tr>
                    </thead>
                    <tbody>
                      <?php $posts = Typecho_Widget::widget('Widget_Contents_Post_Admin'); ?>
                      <?php if($posts->have()): ?>
                        <?php while($posts->next()): ?>
                        <tr id="<?php $posts->theId(); ?>">

                            <td><input type="checkbox" value="<?php $posts->cid(); ?>" name="cid" onclick="checkeds(this)"/></td>
                            <td class="center"><?php $posts->cid(); ?></td>

                            <td>
                            <?php if ('publish' == $posts->status): ?>
                            <a href="<?php $posts->permalink(); ?>" title="<?php _e('浏览 %s', $posts->title); ?>"><i class="i-exlink"></i></a>
                            <?php endif; ?>
                            </td>

                            <td<?php if ('draft' != $posts->status && 'waiting' != $posts->status): ?> colspan="2"<?php endif; ?>>
                            <?php if (isset($rating[$posts->cid])): ?>
                            <a href="<?php echo $_SERVER['REQUEST_URI'], '&amp;cid=', $posts->cid; ?>"><?php $posts->title(); ?></a>
                            <?php else: ?>
                            <?php $posts->title(); ?>
                            <?php endif; ?>
                            
                            <?php if ('draft' == $posts->status || 'waiting' == $posts->status): ?>
                            </td>
                            <td>
                            <span class="balloon right"><?php echo 'draft' == $posts->status ? '草稿' : '待审核'; ?></span>
                            <?php endif; ?></td>

                            <td class="center"><?php /* 评分人数 */ echo isset($rating[$posts->cid]) ? count($rating[$posts->cid], 1) : '--'; ?></td>

                            <td class="center"><?php /* 累计分数 */ echo isset($rating[$posts->cid]) ? array_sum($rating[$posts->cid]) : '--'; ?></td>

                            <td class="center"><?php /* 平均得分 */ echo isset($rating[$posts->cid]) ? number_format(array_sum($rating[$posts->cid])/count($rating[$posts->cid], 1), 2) : '--'; ?></td>

                            <td class="center"><?php $posts->author(); ?></td>

                            <td class="center"><?php $categories = $posts->categories; $length = count($categories); ?>
                            <?php foreach ($categories as $key => $val): ?>
                                <?php echo $val['name'] . ($key < $length - 1 ? ', ' : ''); ?>
                            <?php endforeach; ?>
                            </td>

                        </tr>
                        <?php endwhile; ?>

                        <?php else: ?>
                        <tr>
                          <td colspan="10"><h6 class="typecho-list-table-title">没有任何文章</h6></td>
                        </tr>
                        <?php endif; ?>

                    </tbody>
                </table>
                </div>
                <input type="hidden" name="hash" value="<?php echo $hash; ?>" />
                <input type="hidden" name="do" value="" />
                </form>

            <?php if($posts->have()): ?>
            <div class="typecho-pager">
                <div class="typecho-pager-content">
                    <ul>
                        <?php $posts->pageNav(); ?>
                    </ul>
                </div>
            </div>
            <?php endif; ?>

<?php } ?>

            </div>
        </div>


    </div>
</div>


<script type='text/javascript'>

function req(t){
    if(confirm("确定删除改评分吗？")){
        
        var th = $(t).parent().parent();
    
        $.ajax({
          type: 'POST',
          url: '<?php echo $options->pluginUrl; ?>/PostRating/rating.php',
          data: { created: th.attr('id'), hash: '<?php echo $hash; ?>', type: 'flo' },
          success: function(res){
            th.fadeOut();
            th.delay(500).remove();
          }
        })
　　
    }
}

function req_dou(t){

    if(t == 'created'){
        
        var th = $("input[name='created']:checked").parent().parent();
        
        var created = $("input[name='created']:checked").map(function(){
            return this.value;
        }).toArray();


        if(!created.length){
            alert('请选择要删除的评分！');
        }else{
            if(confirm("确定删除选中的评分吗？")){
                $.ajax({
                    type: 'POST',
                    url: '<?php echo $options->pluginUrl; ?>/PostRating/rating.php',
                    data: { created: created, hash: '<?php echo $hash; ?>', type: 'dou' },
                    success: function(res){
                        th.fadeOut();
                        th.delay(500).remove();
                    }
                })
            }

        }
    }else if(t == 'cid'){
        
        var th = $("input[name='cid']:checked").parent().parent();
        
        var cid = $("input[name='cid']:checked").map(function(){
            return this.value;
        }).toArray();
            

        if(!cid.length){
            alert('请选择要删除评分的文章！');
        }else{
            if(confirm("确定删除选中文章的评分吗？")){
                $.ajax({
                    type: 'POST',
                    url: '<?php echo $options->pluginUrl; ?>/PostRating/rating.php',
                    data: { cid: cid, hash: '<?php echo $hash; ?>', type: 'dou' },
                    success: function(res){
                        th.find('td').eq(3).html(th.find('td').eq(3).find('a').html());
                        th.find('td').eq(4).html('--');
                        th.find('td').eq(5).html('--');
                        th.find('td').eq(6).html('--');
                    }
                })
            }
        }
    }
}

</script>


<?php
include 'copyright.php';
include 'common-js.php';
include 'table-js.php';
include 'footer.php';
?>


<script>
    $(function(){
        $(".typecho-page-main a").attr("target","_self");
    })
</script>