<?php
if ('POST' != $_SERVER['REQUEST_METHOD']) {
    header('Allow: POST');
    header('HTTP/1.1 405 Method Not Allowed');
    header('Content-Type: text/plain');
    exit;
}

if(strpos($_SERVER['HTTP_REFERER'], $_SERVER['HTTP_HOST']) === false) {
    exit('Access denied');
}

/** Sets up the Typecho Environment. */
require(dirname(__FILE__) .'/../../../config.inc.php');
Typecho_Widget::widget('Widget_Init');

$rating  = (isset($_POST['rating']))  ? (int)$_POST['rating'] : 0;
$cid     = (isset($_POST['cid']))     ? (int)$_POST['cid']    : 0;
$hash    = substr(md5(Typecho_Widget::widget('Widget_User')->login), -10);

// $delete  = (isset($_POST['created'])) ? substr($_POST['created'], strpos($_POST['created'], '-') + 1) : '';

$db = Typecho_Db::get();

if ($rating && $cid) {

    $ip = isset($_SERVER["HTTP_X_FORWARDED_FOR"]) ? $_SERVER["HTTP_X_FORWARDED_FOR"]
     : (isset($_SERVER["HTTP_CLIENT_IP"]) ? $_SERVER["HTTP_CLIENT_IP"] : $_SERVER["REMOTE_ADDR"]);

    $user = Typecho_Widget::widget('Widget_User');
    $name = $user->hasLogin() ? $user->screenName : Typecho_Cookie::get('__typecho_remember_author', '');

    $created = time() + Typecho_Widget::widget('Widget_Options')->timezone;

    /* insert data */
    $db->query("INSERT INTO ". $db->getPrefix() ."postrating VALUES ('$cid', '$rating', '$ip', '$name', '$created')");

    // for debug
    //echo '$cid='.$cid.' $rating='.$rating.' $ip='.$ip.' $name='. $name.' $created='.$created;

} elseif (isset($_POST['hash']) && $_POST['hash'] == $hash) {

    /* 单个评分删除 */
    if($_POST['type'] == 'flo'){
        $delete  = (isset($_POST['created'])) ? substr($_POST['created'], strpos($_POST['created'], '-') + 1) : '';
        $db->query($db->delete('table.postrating')->where('created = ?', $delete));
    }
    
    if($_POST['type'] == 'dou'){
        //多个勾选删除
        if (isset($_POST['created'])) {
            $created = $_POST['created'];
            $select = $db->delete('table.postrating');
            foreach($created as $row) {
                $select->orWhere('created = ?', $row);
            }
            $db->query($select);
    
        // 文章勾选删除
        } elseif (isset($_POST['cid'])) {
            $cid = $_POST['cid'];
            $select = $db->delete('table.postrating');
            foreach($cid as $row) {
                $select->orWhere('cid = ?', $row);
            }
            $db->query($select);
        }
    }
    

}


exit;
